//
// FileWriter.swift
//  Picasso
//
//  Created by Mladen.Nisevic on 20/12/2022.
//  Copyright © 2022 BetVictor Ltd. All rights reserved.
//
import Foundation

// MARK: - Misc
final class FileWriter {
    
    static func write(_ content: String, toFile: ExportFilePath, brand: BrandName? = nil) {
        let fileURL = toFile.path(brand?.id)
        let actualContent = try? String(contentsOfFile: fileURL, encoding: .utf8)
        guard content != actualContent else { print("Ignorning \(fileURL)"); return }
        var content = content
        if fileURL.hasSuffix(.dotSwift) {
            content = generateHeader(fileURL) + .newLines() + content
        }
        do {
            try content.write(toFile: fileURL, atomically: false, encoding: String.Encoding.utf8)
        } catch let error as NSError {
            print("Error writing to file ", error)
        }
    }

    static func generateHeader(_ fileURL: String) -> String {
        var fileName = String.empty
        if let url = URL(string: fileURL) {
            fileName = url.lastPathComponent
        }
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = .yyyy
        let copyrightYear = dateFormatter.string(from: Date())
        return """
        // This class was auto-generated by AppearanceParser
        //
        // \(fileName)
        // Picasso
        //
        //  Copyright © \(copyrightYear) BetVictor. All rights reserved.
        //
        """
    }
}
